//Par Fcalva et est sous GPLv3

#pragma once

#include <gint/display.h>

#include "C3D/fixed.h"
#include "C3D/game.h"
#include "C3D/sprites.h"
#include "C3D/moteur.h"
#include "C3D/map.h"
#include "C3D/config.h"

#include "game.h"

#define WEAP_ANIM_C 8
#define WEAP_FRAMES_C 8

typedef struct {
  bopti_image_t *frames[WEAP_FRAMES_C];
  int8_t x;
  int8_t y;
  int8_t framec;
  int8_t frame_hit;
} WeapAnim;

void death_anim(RcGame *game);

void init_gfx();

void draw_gui(CCGame *game);
