//Par Fcalva, et est sous GPLv3

#pragma once

#include "C3D/game.h"

enum {
  stype_frenguy = 4, 
  stype_anvilpick = 7
};

enum {
  weap_none = 0,
  weap_hands = 1,
  weap_anvilstick = 2
};

typedef struct {
  RcGame _bgame;
  int8_t curr_map;
  int8_t hit;
  int8_t curr_weapon;
  int8_t weapon_use;
} CCGame; //CpC game Game struct

typedef struct {
  fixed_t range;
  int dmg;
} WeaponStat;

void cc_load_msprites(Sprite *mapsprites, int spritec);

Sprite *cc_mksprite(V2d pos, int type);

int cc_rmsprite(int pos);

void use_weapon(CCGame *game);

int cc_logic_onframe(CCGame *game);

void init_logic();
